declare -i loadNum
clean
iconSize=128

get_search_icon ()
{
	href="#library=$library&tab=icon_selector,$CLASS,$ID&search=$*"
	aClass=subTab
}

theme_view ()
{
	href="#library=$library&tab=header,$view,$Id"
	aClass=new_tab
	get_icon
	.icon
}

theme_browser ()
{
	href="#library=$library&tab=header,$browser,$Id"
	aClass=browser

	h4=${trCols[$Name]:-$Name}
	h5=$count
	counting=${tr[$library]}
	Name="$h4 ($h5)"

	get_icon
	.icon
}

theme_header ()
{
	aClass=null
	get_icon
	.icon
}

more ()
{
	echo "<span class=more><a  class=more></a></span>"
}

context ()
{
	menu context "$@"
}

editable ()
{
	+ $1 id=$2 onclick="editData(this)" onblur="saveData(this)"
		echo -n "${!2}"
	- $1
}

menu ()
{
	local menu=() name href i j opts IFS class=menu liclass
	[[ $1 = context ]] && class+=\ context && shift

	i ()
	{
		local "$@" selected liclass
		[[ $1 = selected ]] && selected=1
		if [[ $class = submenu\ * ]]; then
			echo "<li class=submenu><a class=submenu href='${href:-#}'>$name</a>$html"
			local submenu=yes
			menu ${class#* }
			- li
		else
			liclass=(${selected:+selected} $liclass)

			echo "<li id='$id' ${liclass:+class='${liclass[*]}'}><a ${class:+class=$class} title='$title' href='${href:-#}'>$name</a>$html</li>"
		fi
	}

	+ div class="$class" id=$1
		[[ $submenu ]] || + span class=arrow; - span

		+ ul
			for i
			{
				if [[ $i = .* ]]; then
					$i
				else
					menu_$i
				fi

				if [[ $menu ]]; then
					IFS=$ifs
					set -- "${menu[@]}"
					for j
					{
						IFS=,
						set -- ${j[*]}
						i name="$1"	class="$2"	href="$3"
					}
				fi
			}
		- ul
	- div
}

menu_sub_tab ()
{
	menu=(
		'Remove from here',disabled
	)
}

menu_unsaved ()
{
	menu=(
		'Save',disabled
		'Discart',discartTab
	)
}

menu_icons ()
{
	menu=(
		${tr[view]^},submenu\ view
		${tr[order]^},submenu\ order
	)
}

menu_view ()
{
	+ li id="$id" class=disabled
		+ input type=radio checked
		+ a class=disabled href=\#order=$i title=Ascending
			% Normal icons
		- a
	- li

	+ li id="$id" class=disabled
		+ input type=radio
		+ a class=disabled href=\#order=$i title=Ascending
			% Big icons
		- a
	- li
}

menu_order ()
{
	IFS=,
	local i j o flow order=($order)
	IFS=$ifs

	for i in "${orders[@]}"
	{
		s= flow=asc id=$i

		for j in "${order[@]}"
		{
			if [[ $i = ${j%% *} ]]; then
				s=selected
				[[ ${j##* } = desc ]] && flow=desc
				id=$j
				break
			fi
		}

#		i $s id="$id" name="${tr[$i]^}" title=Ascending class=order href=\#order=$i html="<a class=order id=desc title=Descending href=\#order=$i%20desc></a>"

		+ li id="$id"
			+ input type=checkbox ${s:+checked id=checked} class=order
			+ a class=order href=\#order=$i title=Ascending
				% ${tr[$i]^}
			- a
			+ a class=order id=desc title=Descending href=\#order=$i%20desc; - a
		- li
	}
}

menu_basic ()
{
	menu=(
		Reload,disabled
		Close,disabled
	)
}

menu_tabs ()
{
	local name
	set -- "${Pages[@]}"
	shift 2
	while [[ $1 ]]; do
		name=${tr[$1]:-$1}
		echo -n "<li><a href='$2' class=subTab>${name^}</a></li>"
		shift;shift
	done
}

menu_context ()
{
	menu=(
		"${tr[add_to_holder]^}",disabled
		${header:+"${tr[remove_from_here]^}",remove_from}
		"${tr[remove]^}",remove
	)
}


########################
#		HTML
########################

#CLASSES

html ()
{
	local el=div id class

	html_$1
	echo "<$el${id:+ id='$id'}${class:+ class='$class'}>"
	.content
	echo "</$el>"

	clean .content
}

html_eid () {
	echo "<div id=$1${2:+ class=$2}>"
		html_$1
	echo "</div>"
}

html_icon ()
{
	if [[ $src ]]; then
		[[ $alpha ]] && class= || class=shadow
		TEXT=
		style="{background-image:url('$src');width:${width:-$iconSize};height:${height:-$iconSize};}"
	else
		class=no_icon
		style=

		if [[ $Width && $iconSize -gt 32 ]]; then
			class+=\ shadow
			icon_text=$Name
		else
			[[ $noiconAlpha ]] && class+=\ shadow
			src=$noicon
			style="{background-image:url('$src');}"
			icon_text=
		fi

		#[[ $SRC ]] && style="{background-image:url('$SRC');}"
		TEXT=$icon_text
	fi

	echo -n \
	"<li id='$Id' class='${liclass[*]}'>
		<div class=icon>
			<a href='$href' class='$aClass' title=\"${Name//\"/&quot;}\">
				<span class='$class' style=\"$style\">$TEXT</span>
			</a>
			$emblems
		</div>
		<div class=details>"
			if [[ $Details ]]; then
				.details
			else
				echo -n "<a href='$href' class='$aClass' title='$Name'><h4>$h4</h4><h5>$h5</h5><span class=counting>$counting</span></a>$html"
			fi
		echo -n \
		"</div>
	</li>"
}

+ ()
{
	local v=\<$1 value;shift
	while [[ $1 ]]; do
		if [[ $1 = *=* ]]; then
			value=${1//\"/&quot;}
			v+=\ ${value/=/=\"}\"
		else
			v+=" $1"
		fi
		shift
	done
	echo -n $v\>
}

- () { echo -n "</$1>";}
+- () { echo -n "<$1>${*:2}</$1>";}

icons ()
{
	local "${@:2}"

	+icons
	icons_$1
	-icons
}

+icons ()
{
	echo "<ul id='$Class' class='icons s$iconSize${iconsClass:+ $iconsClass}'>"
}

-icons () { echo "</ul>";}

icons_libraries ()
{
	alpha=yes

	for Id in ${Libraries[*]}
	{
		get_library $Id

		href=\#library=$Id
		liclass=($selected $hidden)
		aClass=library
		Name=${tr[$Id]:-$Id} Name=${Name^}

		html_icon
	}
}

html_section ()
{
	ID=${QUERY_STRING##*,}
	iconSize=16 alpha=yes

	panel_sections
	.panel
}

panel ()
{
	local hidden name editable alpha=yes iscroll context liclass id meta\
	iconSize=16

	clean .menu .context .panel
	[[ $page ]] && offset=$((page*limit))

	panel_$*

	if [[ $iscroll && $page ]]; then
		.panel
	else
		[[ $panel ]] || + div id=${id:-$1} class="panel${hidden:+ hidden}"
		if [[ -z $hidden ]]; then
			+ h2
				+ a class=expander href="#"
					+ div id="expander"
					- div

					[[ $name ]] || name=$1
					echo ${tr[$name]:-$name}
				- a
			- h2

			[[ $editable ]] && more $id

			[[ $iscroll ]] && + meta page=1 href="?$QUERY_STRING"
			context ${menu[*]:-.context}

			+ div class=content
				[[ $context ]] && context ${context[*]:-.context}

				+ meta href="$meta"
				+icons
					.panel
				-icons
			- div
		fi
		[[ $panel ]] || - div
	fi
}

panel_sections ()
{
	editable=yes
#	context=sections
	Class=sections
	meta="?$QUERY_STRING&eid=section"

	.panel ()
	{
		if [[ $ID ]]; then
			local Browsers=($ID)
		else
			get_elements_from Browsers
		fi

		get_counts #${Browsers[*]}
		#set -- ${counts[$library]}

		aClass=sections

		for group in ${Browsers[*]}
		{
			get_section $group
			liclass=(hidden) checked= h5=

			if -var group in ${sections[*]}; then
				liclass=()
				checked=yes
			fi

			h5=${counts[$group]}

			Id=$group
			[[ $group = $view ]] && liclass+=(selected2)
			[[ $group = $browser ]] && liclass+=(selected)

			h4=${tr[$group]^}
			url="$Url&browser=$group"

			href=$url
			src=web/icons/16/$icon.png

			html="<input type=checkbox class=toggle_item ${checked:+checked}>
<input type=checkbox class=sections checked>
<a href='#library=$library&view=$group&tab=view' class=view title='view $h4'></a>"

			html_icon
		}
	}
}

panel_browser ()
{
	name=${tr[$browser]}
	Class=$browser
	iscroll=yes
	menu=()
	id=$Class

	get_section $Class
	menu=($menu icons)

	context=context
	meta="?$QUERY_STRING&eid=sql&theme=browser,$Class"

	-var view in ${Browsers[*]} || view=$Browsers

	.panel ()
	{
		src=web/icons/16/$browser.png\?$app_version

		theme browser $browser
	}
}

#IDS:

html_consult ()
{
	+ form name=input action=sql.cgi method=post enctype=text/plain
		+- h2 consultar
		+ input type=hidden name=eid value=consult
		+ textarea type=text rows=4 cols=48 name=search
		- textarea
		+ input type=submit
	- form

	echo $search
}

html_page ()
{
	for i in ${appearance[*]}
	{
		local class=${i%%/*} id=${i##*/} html_appearance
		html_appearance="<link class=$class id=$id href='web/appearance/$class/$id?$$' type=text/css rel=stylesheet>"
	}

	template < $path_app/page.html
}

icon ()
{
	echo "<div class='icon s$1' id=$2><a class=$3 href='$4'></a></div>"
}

search ()
{
	local empty onkeyup='searchKeyup(this)' onsubmit='return searchSubmit.apply(this)' "$@"
	[[ $search ]] || empty=empty

	echo "
	<form class=search name=input action='$Url' method=get onsubmit='$onsubmit'>
		<input type=hidden name=library value=$library>
		<div class='icon s16' id=search></div>
		<input class='search $empty' type=text name=search value='$search' onkeyup='$onkeyup'>
		<div class='icon s16' id=clear>
			<a class=clear></a>
		</div>
	</form>"
}

searchMain ()
{
	search onkeyup+=';searchKeyupTop(this)' onsubmit='return searchSubmitMain.apply(this)'
}

info ()
{
	+ div class=info
		+ div class=icon\ s128 id=${icon:-wip}; - div
		+ div class=head
			if [[ $head ]]; then
				cat $path_app/tabs/$head.html
				head=
			else
				.head
			fi
		- div
	- div
}

rating ()
{
	local value disabled
	if [[ $1 && $1 != 0 ]]; then
		local value=$((100/rating_max*${1%%.*}))
	else
		value=0
		disabled=disabled
	fi

	+ div class="rating $disabled"
		+- span
		+  span style="width:$value%;";- span
	- div
}

html_sidebar ()
{
	panel sections
	if [[ $browser ]]; then
		+ div class=panel id=$browser
			+ div class=loading; - div
			#load panel=browser
			script "\$(this).load('?library=$library&panel=browser&browser=$browser')"
		- div
	fi
}

load ()
{
	[[ $1 != \?* ]] && local url="?$QUERY_STRING&$1" || local url=$1

	+ meta class=script id=$$$loadNum href=$url
		+ script type='text/javascript'
			echo "script('$$$loadNum')"
		- script
	- meta

	loadNum+=1
}

script ()
{
	echo "
	<meta class='script' id='$$$loadNum'>
		<script type='text/javascript'>
			Script('$$$loadNum',function () {
				$1
			})
		</script>
	</meta>
	"

	loadNum+=1
}

html_options () {
	cd web/appearance

	for dir in *
	{
		cd $dir
		% Theme:\

		+ select id=themes onchange="applyCss(this)"

			for theme in *.*
			{
				href=web/appearance/$dir/$theme?$$
				name=${theme%.*}
				id=$theme h4=$name h5=$dir

				path=$dir/$theme
				-var path in ${appearance[*]} && selected=selected || selected=

				echo "<option value='$href' id='$id' ${selected:+selected='selected'}>$h4</option>"
			}

		- select

		cd ..
	}

	cd ../..
}

putLibraries ()
{
	init_library movies
	get_counts

	+ ul id=libraries class="icons s128"

		for library in ${Libraries[*]}
		{
			aClass=topTab
			href="#library=$library&tab=library,$library"
			h4=${library^}
			h5=
			src=web/icons/128/$library.png
			Id=$library
			alpha=yes
			emblems=
			liclass=disabled
			Name="Not implemented"

			if ! -var library in ${librariesDisabled[*]}; then
				h5=${counts[$library]}
				Name=$library
				liclass=

				emblems="<div class=emblems style='width: 128;'>
					<div class='icon s32' id=add><a class=topTab href='?library=$library&tab=add&Id=folders' title='Add movies'></a></div>
				</div>"
			fi
			html_icon
		}
	- ul
}

hasOwnTable ()
{
	[[ $1 = filters ]] && return 1
	local _Id _Name
	get_section $1

	if -var _Id in ${tables[*]} ; then
		get_tables $_Id
		if [[ $unique != *,* ]]; then
			return 0
		fi
	fi

	return 1
}
icons_table ()
{
	+ table
		#~ + thead
			#~ .thead
		#~ - thead
		+ meta $meta
		+ tbody id="$Class" class="icons s$iconSize${iconsClass:+ $iconsClass}"
			.icons
		- tbody
	- table
}

icons_ul ()
{
	+ meta $meta
	+icons
		.icons
	-icons
}

html_sql ()
{
	[[ $tab = view,* || $tab = header,* ]] && op+=("${tab#*,}")

	IFS=,
	set $theme
	IFS=$ifs
	theme $1 $2
}

tabs ()
{
	local class=tabs name id=top
	[[ $header ]] && id=

	echo "
	<div class=tabs id=$id>
		<ul class=titles></ul>"

	#if [[ $Pages ]]; then
		more
		menu tabs
	#fi

	echo "
		<ul class=contents></ul>
	</div>"

	script "newTab('$1'${header:+,this})"
}

tab ()
{
	IFS=,
	set -- $tab
	IFS=$ifs

	if [[ $1 = *.html ]]; then
		template < $path_app/tabs/$1
	else
		clean .toolbar .content .menu
		unset -f .icons
		iscroll= menu=() id= title=

		-fn tab_$1 || tabClass=wip
		tab_$1 "${@:2}"

		if [[ $content != no ]]; then
			[[ $title ]] && title=${tr[$title]:-$title} || title=${tr[$1]:-$1}

			if [[ ! ${tab[1]} ]]; then
				+ meta title="${title^}" id="${id:-$1}" ${iscroll:+page=1} href="?$QUERY_STRING" icon=$icon
				  menu ${menu[*]:-.menu}

				+ div class=toolbar
					.toolbar
					unset -f .icons
				- div

				+ div class=content
					context context
					.content
					if -fn .icons; then
						if [[ $type = table ]]; then
							icons_table
						else
							icons_ul
						fi
					fi
				- div
			else
				.content
				if -fn .icons; then
					if [[ $page ]]; then
						offset=$((page*limit))
						.icons
					else
						context context
						if [[ $type = table ]]; then
							icons_table
						else
							icons_ul
						fi
					fi
				fi
			fi
		fi
	fi
}

tab_library ()
{
	content=no
	+ meta icon=$library title=$library href="?$QUERY_STRING"

	get_library $library

	if [[ ! $disabled ]]; then
		searchMain
		+ div class=sidebar
			load eid=sidebar
		- div
	fi

	+ div class=content
		if [[ $disabled ]]; then
			title=${tr[$library]^}
			icon=$library

			.head ()
			{
				+- h1 $title
				+- p  Not implemented.
			}

			info
		elif [[ $library ]]; then
			tabs "?library=$library&view=$view&tab=view"
		fi
	- div
}

tab_view ()
{
	if [[ $library ]]; then
		get_elements_from Browsers

		if -var view in ${Browsers[*]} ; then
			if [[ $2 ]]; then
				op+=("$1,$2")
				header=yes
			fi

			iconSize=128
			Class=$view
			iscroll=yes

			get_section $Class
			title=${tr[$view]:-$view}
			menu=($menu icons)
			id=view,$view
			toolbar=

			.toolbar ()
			{
				[[ $toolbar ]] && echo $toolbar
			}

			view $view

			.content ()
			{
				meta="href=?$QUERY_STRING&eid=sql&theme=view,$Class"

				.icons ()
				{
					theme view $Class

					if [[ $dbIsEmpty && $Class = movies ]]; then
						+ div class=tab_info
							% ${tr[emptyLibraryMessage]//%items/${tr[movies]}}
						- div
					fi
				}
			}
		else
			id=$view
			view=$library

			tab_header $view "$id"
		fi
	elif [[ $search ]]; then
		tab_search
	fi
}

tab_header ()
{
	CLASS=$1 ID=$2 header=yes

	get_section $CLASS

	limit=1
	order=
	QUERY="$tables.$_Id = '$ID'"

	theme get header $CLASS ID

	id=header,$Class,$Id

	if [[ $Name = /*/* ]]; then
		title=${Name##*/}
	else
		title=${trCols[$Name]:-$Name}
	fi

	menu=(.menu basic)

	.content ()
	{
		+ meta href="?$QUERY_STRING&eid=sql&theme=header,$Class&limit=1"
		iconsClass=header

		+icons
			theme_header
		-icons

	  #open tab view or default
		if [[ $Pages && $Class = $view ]]; then
			href=${Pages[1]}
		else
			href="?$QUERY_STRING&tab=view,$CLASS,$ID"
		fi

		tabs "$href"
	}
}

tab_icon_selector ()
{
	iscroll=yes
	browser=$1 id=$2
	content=no
	+ meta title="Icon Selector" iscroll=google_images page=1 href="?$QUERY_STRING"

	+ div class=toolbar
		search
	- div

	+ div class=content
		iconSize=150
		+icons
			html_google_images
		-icons
	- div
}

tab_icon_selector ()
{
	title=Icon\ Selector
	iscroll=yes
	browser=$1 id=$2

	.toolbar ()
	{
		search
	}

	.content ()
	{
		limit=20
		iconSize=150
		aClass=setIcon

		.icons ()
		{
			while get_google_images; do
				href="?library=$library&action=setIcon,$browser,$id&url=${href//%3D/=}"
				html_icon
			done
		}
	}
}

html_google_images ()
{
	limit=20
	get_google_images
	aClass=setIcon

	for (( i = 0; i < Max; i++ ))
	{
		href="?library=$library&action=setIcon,$browser,$id&url=${href[$i]//%3D/=}"
		src=${src[$i]}
		width=${width[$i]}
		height=${height[$i]}
		h5=${h5[$i]}

		html_icon
	}
}

tab_wip ()
{
	title=$1
	icon=$2

	.content ()
	{
		icon=${icon:-wip}

		.head ()
		{
			+- h1 Under Construction
		}

		info
	}
}

tab_holder ()
{
	tab_wip holder holder
}

tab_explore ()
{
	.toolbar ()
	{
		icons libraries iconSize=32
		more
		search
	}

	.content ()
	{
		icon=wip

		.head ()
		{
			cat $path_app/tabs/explore.html
		}

		info
	}
}

tab_iframe ()
{
	id=iframe-$title
	.content ()
	{
		url=${url//%3D/=}

		echo "
		<iframe class=hidden src='$url' onload='\$(this).removeClass(\"hidden\").next().remove();'></iframe>
		<div class=loading></div>"
	}
}
