CREATE TRIGGER rated BEFORE UPDATE OF rating ON movies
BEGIN
	UPDATE movies SET rated = datetime('NOW','localtime') WHERE movies = OLD.movies AND rated = '';
END;

CREATE TRIGGER on_disk AFTER INSERT ON movies
WHEN NEW.movies IN (SELECT movies FROM files WHERE movies = NEW.movies) BEGIN
	UPDATE movies SET on_disk = '1' WHERE movies = NEW.movies;
END;

CREATE TRIGGER on_disk_files BEFORE UPDATE OF movies ON files
BEGIN
	UPDATE movies SET on_disk = '1' WHERE movies = NEW.movies;
END;

CREATE TRIGGER on_disk_files_remove AFTER UPDATE OF movies ON files
WHEN OLD.movies NOT IN (SELECT movies FROM files WHERE movies = OLD.movies) BEGIN
	UPDATE movies SET on_disk = '' WHERE movies = OLD.movies;
END;
